options mprint mlogic symbolgen;
libname sdata 'd:\pm naaqs\summer03';

data stpall(keep=site poc_t zdate pmt dur meth); set sdata.P81102y20002002d28may03raw sdata.P81102h
(rename=(value=v sdate=zdate));
if meth in (' ' '062','063','064','065','071','073','076','079','081',
'098','122','124','125', '126','127','130','131','132') and v ne .;
poc_t=poc;
pmt=v;
if meth=' ' and obs lt 18 then delete;
if meth=' ' then  dur='H'; else dur='D';
run;
proc sort; by site zdate poc_t dur;
data stp2; set stpall; by site zdate poc_t dur;
if first.zdate;
ttype='S';

proc sort data=sdata.presstempall; by site zdate;
data stp2loc;
merge stp2 (in=match) sdata.presstempall; by site zdate;
if match; 
if temperature and pressure ne . then do;
pmt=pmt*298/temperature*pressure/760;
end;
else do;
pmt=pmt*298/tempnws*pressnws/760;
end;
if pmt ne .;
run;


data ltpall(keep=site poc_t zdate pmt dur meth); set sdata.P85101y20002002d28may03raw sdata.P85101h
(rename=(value=v sdate=zdate));
if meth in (' ' '062','063','064','065','071','073','076','079','081',
'098','122','124','125', '126','127','130','131','132') and v ne .;
poc_t=poc;
pmt=v;
if meth=' ' and obs lt 18 then delete;
if meth=' ' then  dur='H'; else dur='D';
run;
proc sort; by site zdate poc_t dur;
data ltp2; set ltpall; by site zdate poc_t dur;
if first.zdate;
ttype='L';
run;

*pick ltp over stp;
data standard; set ltp2 stp2loc;
proc sort; by site zdate ttype;
data sdata.pm10raw_lshd; set standard; by site zdate ttype;
if first.zdate;
meth_t=meth;
drop meth;

proc sql; create table fine as select distinct site,poc as poc_f,meth as meth_f,zdate, v as pmf
from sdata.P88101y20002002d28may03raw where meth in ('116','117','118','119','120','123') and 
v ne .; quit;
proc sort; by site zdate poc_f;
data fine2; set fine; by site zdate poc_f;
if first.zdate;
run;

data sdata.coarseraw; 
merge fine2 sdata.pm10raw_lshd;; by site zdate;
pmc=pmt-pmf;
if pmc ne .;
run;

proc  sql; select dur,ttype,count(*) from sdata.coarseraw group by ttype,dur; quit;