options mprint mlogic symbolgen;
libname sdata 'd:\pm naaqs\summer03';

*First get AQS temp press;
proc sql; create table sitesd as select distinct site from sdata.P81102y20002002d28may03raw
where meth in (' ' '062','063','064','065','071','073','076','079','081',
'098','122','124','125', '126','127','130','131','132');quit;;
proc sql; create table sitesh as select distinct site from sdata.P81102h;quit;
data stpsites; merge sitesd sitesh; by site;
stpin=1;
run;

data ptemp (keep=site date temp);set sdata.p68105;
temp=value;
date=sdate;
if temp lt 100;
temp=temp+273.15;
run;

data ppress (keep=site date press); set sdata.p68108;
press=value;
date=sdate;
if 400 lt press lt 2000;
run;

data temp;set sdata.p62101h;
temp=value;
date=sdate;
if obs ge 18;
if temp lt 200;
temp=5/9*(temp-32)+273.15;
proc summary;by site poc date;
var temp;
output out=temp2 mean=temp n=hours;
run;

data press;set sdata.p64101h;
press=value;
date=sdate;
if obs ge 18;
if 300 lt press lt 2000;
press=press/1.33322;
proc summary;by site poc date;
var press;
output out=press2 mean=press n=hours;
run;

data allmet; set ppress press2 ptemp temp2;
proc sql; create table presstemp as select distinct site,date as zdate,avg(press) as pressure, 
avg(temp) as temperature from allmet group by site,date having pressure ne . and temperature
ne .;
quit;

proc sql;  create table sdata.presstempAQS as select distinct a.site,zdate,pressure,temperature from
presstemp a, stpsites b where a.site=b.site; quit;


*next get nws met;
libname ws 'g:\user\share\billcox\mark\sasdat';

*convert nws met to kelvin - mm hg and aggregate by day;
data nwsmet;
set ws.met;
temp=5/9*(t_fah-32)+273.15;
press=stnpr/1.33322;
zdate=sdate;
data ws00; set nwsmet; 
if year(zdate)=2000;
drop hr sdate t_fah stnpr;
run;
data ws01; set nwsmet; 
if year(zdate)=2001;
drop hr sdate t_fah stnpr;
run;
data ws02; set nwsmet; 
if year(zdate)=2002;
drop hr sdate t_fah stnpr;
run;
proc sort data=ws00; by id lat lon zdate;
proc sort data=ws01; by id lat lon zdate;
proc sort data=ws02; by id lat lon zdate;
proc summary data=ws00; by id lat lon zdate;
var temp press;
output out=wsout00 mean=temp press n=nt np;
proc summary data=ws01; by id lat lon zdate;
var temp press;
output out=wsout01 mean=temp press n=nt np;
proc summary data=ws02; by id lat lon zdate;
var temp press;
output out=wsout02 mean=temp press n=nt np;
data sdata.ws; set wsout00 wsout01 wsout02;
if temp ne . and press ne .;
if nt ge 18 and np ge 18;
drop _type_ _freq_;
run;

*get closest met id to stp site;
proc sql; create table sites as select distinct SI_ID,
cc_cn_stt_state_code as st, cc_ci_city_code as city,
cc_cn_county_code as cou, site_latitude as lat,site_longitude as long,
site_id as id from aqs.sites; QUIT;
data sites (keep= si_id site lat long city); set sites;
site=st||cou||id;

proc sql; create table stplatlon as select distinct a.site,lat,-1*long as long from stpsites a, sites b where stpin=1
and a.site=b.site having lat ne 0 and long ne 0; quit;
proc sql; create table nwslatlon as select distinct id,lat as lat2, lon as long2 from sdata.ws;
proc sql; create table bothlatlon as select distinct id,site,lat,lat2,long,long2 from stplatlon,nwslatlon; quit;
data cart; set bothlatlon;
 rp=6356.912;d=21.476; 
latR=lat*arcos(-1)/180;    
longR=long*arcos(-1)/180;  
latR2=lat2*arcos(-1)/180;    
longR2=long2*arcos(-1)/180;  

*Polar radius of earth with difference between polar & eq; 
 r=d*(cos(latR2)+cos(latR))*.5+rp;* average radius (km);       
 d=arcos(cos(latR2)*cos(longR2)*cos(latr)*cos(longR)+cos(latR2) 
 *sin(longR2)*cos(latR)*sin(longR)                              
 + sin(latR2)*sin(latR))*r;* distance in km;            
proc sort; by site D;
data sdata.closest; set cart; by site D;
if first.site then do;
closeid=id;
dist=d*.62137;
drop id;
output;
end;
run;
proc sql; create table sdata.presstempnws as select distinct site,id,dist,zdate,temp as tempnws, press as pressnws
from sdata.closest a,sdata.ws b where a.closeid=b.id; quit;

data sdata.presstempall;
merge sdata.presstempaqs sdata.presstempnws; by site zdate;
run;
