libname sdata 'd:\pm naaqs\summer03';

data fine (keep=site poc annmean size pct98);
set sdata.Finalp88101y20002002;
size=1;
run;
proc sort; by site poc;
data fine;
set fine; by site poc;
if first.site;
run;
data coarse (keep=site annmean size pct98);
set sdata.Final_pmcy20002002;
size=2;
run;
data ten (keep=site annmean size pct98);
set sdata.Final_pmty20002002;
size=3;
run;
data all; 
set fine coarse ten;
proc sort; by site;
run;

proc sql; create table sites as select distinct SI_ID,
cc_cn_stt_state_code as st, cc_ci_city_code as city,
cc_cn_county_code as cou, site_latitude as lat,site_longitude as long,
site_id as id from aqs.sites; QUIT;
data sites (keep= si_id site lat long city); set sites;
site=st||cou||id;
proc sort; by site;

data regsize; merge sites all; by site;
if size ne .;
statename=fipstate(substr(site,1,2));
lon=abs(long);
	if statename in ('ME' 'NH' 'VT' 'DC' 'MA' 'RI' 'CT' 'NJ' 'DE') or
		(statename in ('MD' 'PA' 'NY' 'VA' 'WV') and lon lt 78.5) then PMREG=1;
	else if statename in ('NC' 'SC' 'TN' 'GA' 'FL' 'AL' 'MS' 'LA' 'AR') or
		(statename in ('OK' 'TX') and lon lt 97.7) then PMREG=2;
	else if statename in ('KY' 'OH' 'MI' 'IN' 'IL') or
		(statename in ('NY' 'PA' 'WV' 'VA') and lon gt 78.5) or
		(statename in ('WI' 'MN' 'IA' 'MO') and lon lt 91.5) then PMREG=3;
	else if statename in ('ND' 'SD' 'NE' 'KS') or 
		(statename in ('MN' 'WI' 'IA' 'MO') and lon gt 91.5) or
		(statename in ('CO') and lon lt 104.05) then PMREG=4;
	else if statename in ('NM' 'AZ') or
		(statename in ('OK' 'TX') and lon gt 97.7) or
		(statename in ('NV' 'CA') and lon lt 115.5 and lat lt 37) then PMREG=5;
	else if statename in ('WA' 'ID' 'MT' 'WY' 'UT' 'OR') or
		(statename in ('CO') and lon gt 104.05) or
		(statename in ('CA' 'NV') and lat gt 37) then PMREG=6;
	else if statename in ('CA' 'NV') and lat lt 37 and lon gt 115.5 then PMREG=7;
		else PMREG=0;
	if pmreg = 0 then PMREGDESC='Not in PMREG Region';
	else if pmreg=1 then PMREGDESC='Northeast';
	else if pmreg=2 then PMREGDESC='Southeast';
	else if pmreg=3 then PMREGDESC='Industrial Midwest';
	else if pmreg=4 then PMREGDESC='Upper Midwest';
	else if pmreg=5 then PMREGDESC='Southwest';
	else if pmreg=6 then PMREGDESC='Northwest';
	else if pmreg=7 then PMREGDESC='Southern California';
if pmreg ne 0; run;
proc sort; by pmreg size;
proc univariate noprint data=regsize;
by pmreg size;
*where size in (1 2);
where size=3;
var annmean;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
run;

data sdata.boxdata_t_amean;
*data sdata.boxdata_fc_amean;
set uniout;

proc sort data=uniout; by pmreg size;
data uniout2;
set uniout; by pmreg size;
if _N_=1 then level=1;
else level+1;

data a; set uniout2;
DO I=1 TO 10;
val=pct95; output;
val=pct05; output;
END;
do i=1 to 26;
val=pct25; output;
val=pct75; output;
val=median; output;
END;
VAL=MIN; OUTPUT;
VAL=MAX; OUTPUT;
run;
/*PROC UNIVARIATE NOPRINT; BY LEVEL;
VAR VAL;
output out=FIXOUT min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
*/
proc univariate noprint data=regsize;
by pmreg size;
*where size in (1 2);
where size=3;
var pct98;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;


data sdata.boxdata_t_p98;
*data sdata.boxdata_fc_p98;
set uniout;

proc sort data=uniout; by pmreg size;
data uniout2;
set uniout; by pmreg size;
if _N_=1 then level=1;
else level+1;

data b; set uniout2;
DO I=1 TO 10;
val=pct95; output;
val=pct05; output;
END;
do i=1 to 26;
val=pct25; output;
val=pct75; output;
val=median; output;
END;
VAL=MIN; OUTPUT;
VAL=MAX; OUTPUT;
run;
PROC UNIVARIATE NOPRINT data=b; BY LEVEL;
VAR VAL;
output out=FIXOUT min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
RUN;

