%macro meta(lib,parameter,intrvl,styear,endyear,flag,vname,userid,userpasswd);
%let sd=01-JAN-&styear;
%let ed=31-DEC-&endyear;
%let fname=&lib..metap&parameter;
libname aqs oracle user=&userid pw=&userpasswd path='aqsprod';

proc sql;
     connect to oracle (user=&userid password=&userpasswd path="aqsprod" buffsize=100);
     create table temp as
     select * from connection to oracle (
select	sites.cc_cn_stt_state_code||sites.cc_cn_county_code||sites.site_id as site, 
		monitors.poc as poc, 
		monitors.pa_parameter_code as parameter,
		monitors.mo_id,
		parameters.parameter_desc as parameterdesc, 
		states.state_abbr as statename, states.state_code as state,
		states.epar_epa_region_code as eparegion,
		counties.county_code as county,
		counties.county_name as countyname,
		county_cities.ci_city_code as city, 
		cities.city_name as cityname, 
		sites.street_address as siteaddress, 
		aqcr_counties.aq_aqcr_code as aqcr, 
		aqcrs.aqcr_desc as aqcrname, 
		state_urbanized_areas.ua_uar_code as urbanarea, 
		urbanized_areas.uar_name as urbanname,
		land_use_types.land_use_type as landuse, 
		location_settings.location_setting as location, 
		sites.site_latitude as latituden, 
		sites.site_longitude as longitudew, 
		sites.utm_zone_num as utmzone, 
		sites.utm_northing as utmnorth,
		sites.utm_easting as utmeast,
		sites.ldp_vert_meas as elevation, 
		msas.msa_code as msa, 
		msas.msa_name as msaname,
		units.unit as units, units.unit_desc as unitsname
from	aqcrs aqcrs, 
		aqcr_counties aqcr_counties, 
		cities cities, 
		counties counties, 
		county_cities county_cities, 
		land_use_types land_use_types, 
		location_settings location_settings, 
		monitors monitors, 
		msas msas, 
		parameters parameters, 
		states states, 
		state_urbanized_areas state_urbanized_areas, 
		units units, 
		urbanized_areas urbanized_areas, 
		sites sites 
where	aqcrs.aqcr_code = aqcr_counties.aq_aqcr_code and 
		counties.stt_state_code = aqcr_counties.cn_stt_state_code and 
		counties.county_code = aqcr_counties.cn_county_code and 
		cities.city_code = county_cities.ci_city_code and 
		cities.stt_state_code = county_cities.ci_stt_state_code and 
		states.state_code = counties.stt_state_code and 
		msas.msa_code = county_cities.msa_msa_code and 
		parameters.parameter_code = monitors.pa_parameter_code and 
		units.unit = parameters.un_unit_standard and 
		urbanized_areas.uar_code = state_urbanized_areas.ua_uar_code and 
		aqcr_counties.aq_aqcr_code = sites.aqcrc_aq_aqcr_code and 
		aqcr_counties.cn_stt_state_code = sites.aqcrc_cn_stt_state_code and 
		aqcr_counties.cn_county_code = sites.aqcrc_cn_county_code and 
		county_cities.cn_county_code = sites.cc_cn_county_code and 
		county_cities.cn_stt_state_code = sites.cc_cn_stt_state_code and 
		county_cities.ci_city_code = sites.cc_ci_city_code and 
		county_cities.ci_stt_state_code = sites.cc_ci_stt_state_code and 
		location_settings.location_setting = sites.Ls_location_setting and 
		land_use_types.land_use_type = sites.lut_land_use_type and 
		state_urbanized_areas.stt_state_code = sites.sua_stt_state_code and 
		state_urbanized_areas.ua_uar_code = sites.sua_ua_uar_code and 
		sites.si_id = monitors.si_si_id and
		monitors.pa_parameter_code = %unquote(%str(%'&parameter%')) order by 4);
%put &sqlxrc; *debug sql;
%put &sqlxmsg; *debug sql;
disconnect from oracle;
quit;
proc sql; create table begend as select distinct MO_mo_ID as mo_id,
	sampling_begin_date as begtime, min(sampling_begin_date) as begtimeo,
	sampling_end_date as endtime from
	aqs.sample_periods group by mo_id;quit;
data begend (keep=mo_id mon_beg mon_end mon_bego); set begend;
	mon_beg=datepart(begtime);
	mon_bego=datepart(begtimeo);
	mon_end=datepart(endtime);
	format mon_beg mon_end mon_bego mmddyy10.; run;
proc sort; by mo_id mon_beg;
data begend2; 
	set begend; by mo_id mon_beg;
	if last.mo_id;
	if mon_end=. or mon_end ge mdy(1,1,&styear);
	if mon_bego le mdy(12,31,&endyear);
	active=1;
proc sort; by mo_id;
data meta_active;
	merge begend2 temp; by mo_id;
	if active=1; 
	if parameter ne ' ';
	if state ne 'CC';
data keepmo (keep=mo_id active);
	set meta_active;
proc sql; create table ob as select distinct
	mot_monitor_obj_type as objective, a.mo_mo_id as mo_id from aqs.monitor_objectives a, 
	keepmo b where a.mo_mo_id=b.mo_id;
quit;
proc sort; by mo_id objective;
data ob2; 
	set ob; by mo_id objective;
	if first.mo_id then n=0;
	n+1;
	charn='MONOBJ'||compress(put(n,2.0));
run;
proc sort; by mo_id;
proc transpose out=tranob;
	by mo_id; var objective; id charn;
run;

proc sql; create table mt as select distinct mo_id,mt_monitor_type as mt,
	datepart(monitor_type_begin_date) as mt_beg,monitor_type_begin_date,monitor_type_end_date,
	datepart(monitor_type_end_date) as mt_end from aqs.monitor_type_assignments a, keepmo b
	where(datepart(monitor_type_end_date)=. or datepart(monitor_type_end_date) gt 
	mdy(1,1,&styear)) and a.mo_mo_id=b.mo_id; quit;
data mt; 
	format mt_beg mt_end mmddyy10.;
	set mt;
run;
proc sort; by mo_id mt;
data mt2; 
	length mtb $15.;
	retain mtb;
	set mt; by mo_id mt;
	if first.mo_id then do; mtb=' '; n=0; end;
	if mt=mtb then delete; else do; n+1; mtb=mt; end;
	charn='MONTYPE'||compress(put(n,2.0));
run;
proc transpose out=tranmt;
	by mo_id; var mt; id charn;
proc sort; by mo_id;
data x.meta&parameter; 
	merge meta_active tranob tranmt;
	by mo_id;
	lat=abs(latituden);
	lon=abs(longitudew);
	if statename in ('ME' 'NH' 'VT' 'DC' 'MA' 'RI' 'CT' 'NJ' 'DE') or
		(statename in ('MD' 'PA' 'NY' 'VA' 'WV') and lon lt 78.5) then PMREG=1;
	else if statename in ('NC' 'SC' 'TN' 'GA' 'FL' 'AL' 'MS' 'LA' 'AR') or
		(statename in ('OK' 'TX') and lon lt 97.7) then PMREG=2;
	else if statename in ('KY' 'OH' 'MI' 'IN' 'IL') or
		(statename in ('NY' 'PA' 'WV' 'VA') and lon gt 78.5) or
		(statename in ('WI' 'MN' 'IA' 'MO') and lon lt 91.5) then PMREG=3;
	else if statename in ('ND' 'SD' 'NE' 'KS') or 
		(statename in ('MN' 'WI' 'IA' 'MO') and lon gt 91.5) or
		(statename in ('CO') and lon lt 104.05) then PMREG=4;
	else if statename in ('NM' 'AZ') or
		(statename in ('OK' 'TX') and lon gt 97.7) or
		(statename in ('NV' 'CA') and lon lt 115.5 and lat lt 37) then PMREG=5;
	else if statename in ('WA' 'ID' 'MT' 'WY' 'UT' 'OR') or
		(statename in ('CO') and lon gt 104.05) or
		(statename in ('CA' 'NV') and lat gt 37) then PMREG=6;
	else if statename in ('CA' 'NV') and lat lt 37 and lon gt 115.5 then PMREG=7;
		else PMREG=0;
	if pmreg = 0 then PMREGDESC='Not in PMREG Region';
	else if pmreg=1 then PMREGDESC='Northeast';
	else if pmreg=2 then PMREGDESC='Southeast';
	else if pmreg=3 then PMREGDESC='Industrial Midwest';
	else if pmreg=4 then PMREGDESC='Upper Midwest';
	else if pmreg=5 then PMREGDESC='Southwest';
	else if pmreg=6 then PMREGDESC='Northwest';
	else if pmreg=7 then PMREGDESC='Southern California';
	drop lat lon;
run;
%mend;

libname x 'd:\pm naaqs\summer03';
%meta(x,81102,7,2000,2002,y,value,sme,alexelikris1);
run;

