libname sdata 'd:\pm naaqs\summer03';
libname dav 'I:\lqn\PMStaffPaper\data';
*run 'meta from aqs' first;
proc sql;
create table s as select distinct site,meth_t as meth,count(*) as ct from sdata.pmtraw_meetscomp
where ttype='S' and dur='D' group by site,meth; 
create table sdobs as select distinct site,count(*) as nobs_sd from sdata.pmtraw_meetscomp
where ttype='S' and dur='D' group by site; quit;
proc sort data=s; by site;
data sd; set s; by site;
if first.site and last.site then do; 
	method_sd=meth;
	output; end;
else if last.site then do; method_sd='999'; output; end;
proc sql;
create table s as select distinct site,meth_t as meth,count(*) as ct from sdata.pmtraw_meetscomp
where ttype='L' and dur='D' group by site,meth; 
create table ldobs as select distinct site,count(*) as nobs_ld from sdata.pmtraw_meetscomp
where ttype='L' and dur='D' group by site; quit;
proc sort data=s; by site;
data ld; set s; by site;
if first.site and last.site then do; 
	method_ld=meth;
	output; end;
else if last.site then do; method_ld='999'; output; end;
run;
proc sql; 
create table shobs as select distinct site,count(*) as nobs_sh from sdata.pmtraw_meetscomp
where ttype='S' and dur='H' group by site; 
create table lhobs as select distinct site,count(*) as nobs_lh from sdata.pmtraw_meetscomp
where ttype='L' and dur='H' group by site; quit;
proc sql; 
create table s as select distinct a.site,a.poc_t as poc,method from sdata.pmtraw_meetscomp
a, dav.Rdh81102d20002002129may03 b where ttype='S' and dur='H' and a.site=b.site and 
a.poc_t=b.poc and method not in ('116' '117' '118' '119' '120' '123'); quit;
proc sort data=s; by site;
data sh; set s; by site;
if first.site and last.site then do; 
	method_sh=method;
	output; end;
else if last.site then do; method_sh='999'; output; end;
proc sql; 
create table s as select distinct a.site,a.poc_t as poc,method from sdata.pmtraw_meetscomp
a, dav.Rdh85101d20002002129may03 b where ttype='L' and dur='H' and a.site=b.site and 
a.poc_t=b.poc and method not in ('116' '117' '118' '119' '120' '123'); quit;
proc sort data=s; by site;
data lh; set s; by site;
if first.site and last.site then do; 
	method_lh=method;
	output; end;
else if last.site then do; method_lh='999'; output; end;

data all; merge sd ld sh lh sdobs ldobs shobs lhobs; by site;
drop method poc ct meth;
run;

data met; set sdata.pmtraw_meetscomp;
if ttype='L' then do; ltp=1; output; end;
else if temperature ne . and pressure ne . then do; ltp=2; output; end;
else if tempnws ne . and pressnws ne . then do; ltp=3; output; end;
else output;run;
proc sql; create table met2 as select distinct site,ltp,count(*) as ct from met group by site,ltp;
data ltp1;set met2; if ltp=1;
nobs_ltp1=ct;
data ltp2;set met2; if ltp=2;
nobs_ltp2=ct;
data ltp3;set met2; if ltp=3;
nobs_ltp3=ct;
run;


data s; set sdata.Final_pmty20002002; 
in=1;
proc sort; by site;
proc sort data=all; by site;

proc sql; create table spoc81102 as select distinct site,poc_t as poc,count(*) as ct
from sdata.pmtraw_meetscomp where ttype='S' group by site,poc order by site,poc;
data spoc81102; set spoc81102; parm=81102;
proc sort data=sdata.meta81102; by site poc;
data meta1; merge spoc81102 sdata.meta81102; by site poc; if ct ne .;
run;
proc sql; create table spoc85101 as select distinct site,poc_t as poc,count(*) as ct
from sdata.pmtraw_meetscomp where ttype='L' group by site,poc order by site,poc;
data spoc85101; set spoc85101; parm=85101;
proc sort data=sdata.meta85101; by site poc;
data meta2; merge spoc85101 sdata.meta85101; by site poc; if ct ne .;
data meta; set meta1 meta2;
proc sort; by site  ct poc;
data metause; set meta; by site ct poc;
retain predpoc;
drop parm parameter;
parameterdesc='PM-10 LOCAL CONDITIONS';
units='105'; unitsdesc='UG/CU METER';
if first.site then predpoc=poc;
if first.site and last.site then output; 
else if last.site then do; multpoc='Y'; poc=predpoc; output; end;

run;

data all; merge s metause sd ld sh lh sdobs ldobs shobs lhobs ltp1 ltp2 ltp3; by site;
drop method ct meth ltp ct;
monid=site||compress(put(poc,1.0));
if in=1;
noobs=an;
siteid=site;
nocompqtr=maxnq11;
qbegin=bq; qend=eq;
drop an;
run;

data sdata.pm10_sitemon_info (keep=
siteid poc monid multpoc parameterdesc nobs_sd nobs_sh nobs_ld nobs_lh  nobs_ltp1 nobs_ltp2 nobs_ltp3 
method_sd method_sh method_ld method_lh state 
statename county countyname city cityname siteaddress aqcr aqcrname urbanarea urbanname
msa msaname landuse location latituden longitudew utmeast utmnorth utmzone
elevation units unitsname montype1 montype2 monobj1 monobj2 pmreg pmregdesc eparegion);
retain 
siteid poc monid multpoc parameterdesc nobs_sd nobs_sh nobs_ld nobs_lh  nobs_ltp1 nobs_ltp2 nobs_ltp3 
method_sd method_sh method_ld method_lh state 
statename county countyname city cityname siteaddress aqcr aqcrname urbanarea urbanname
msa msaname landuse location latituden longitudew utmeast utmnorth utmzone
elevation units unitsname montype1 montype2 monobj1 monobj2 pmreg pmregdesc eparegion;
set all;
data sdata.pm10_sitemon_summary (keep=siteid monid multpoc state statename county countyname city cityname urbanarea urbanname
msa msaname landuse location pmreg pmregdesc eparegion nocompqtr qbegin qend noobs
min pct05 pct25 median pct75 pct95 pct98 pct99 max annmean n2000q1-n2000q4 n2001q1-n2001q4
n2002q1-n2002q4 mean2000q1-mean2000q4 mean2001q1-mean2001q4 mean2002q1-mean2002q4);
retain siteid monid multpoc state statename county countyname city cityname urbanarea urbanname
msa msaname landuse location pmreg pmregdesc eparegion nocompqtr qbegin qend noobs
min pct05 pct25 median pct75 pct95 pct98 pct99 max annmean n2000q1-n2000q4 n2001q1-n2001q4
n2002q1-n2002q4 mean2000q1-mean2000q4 mean2001q1-mean2001q4 mean2002q1-mean2002q4;
set all;
proc sort data=all;
by state county descending pct98;
data hi98 (keep=state statename county countyname pmreg pmregdesc pct98high pct98monid);
set all; by state county descending pct98;
if first.county;
pct98high=pct98;
pct98monid=monid;
proc sort data=all;
by state county descending annmean;
data himean (keep=state statename county countyname pmreg pmregdesc annmeanmax annmeanmonid);
set all; by state county descending annmean;
if first.county;
annmeanmax=annmean;
annmeanmonid=monid;
proc sql; create table cts as select distinct state,county,count(*) as nosites from
all group by state,county;
data sdata.pm10ctymax; 
retain state statename county countyname pmreg pmregdesc nosites pct98high pct98monid annmeanmax annmeanmonid;
merge cts hi98 himean; by state county;
run;