libname sdata 'd:\pm naaqs\summer03';
*run 'meta from aqs' first;
proc sql;
create table meth as select distinct site,poc,meth,count(*) as ct from sdata.P88101raw_meetscomp
group by site,meth;
proc sort; by site;
data meth2 (keep=site poc method); 
length method $8.;
set meth; by site;
if first.site and last.site then do; method=meth; output; end;
else if last.site then do; method='999'; output; end;
proc sort; by method;
run;
proc sql; create table desc as select distinct methodology_code as method, sample_coll_desc as methoddescc,
sample_anal_desc as methoddesca from aqs.sampling_methodologies where pa_parameter_code='88101' order by method;
data meth3; merge meth2 desc; by method;
if site ne ' ';
proc sort; by site poc;

data s; set sdata.Finalp88101y20002002; 
primary=1;
proc sort; by site poc;

data all; merge s sdata.meta88101 meth3; by site poc;
monid=site||compress(put(poc,1.0));
if primary=1;
noobs=an;
siteid=site;
nocompqtr=maxnq11;
qbegin=bq; qend=eq;
drop an;

run;

data sdata.pm25_sitemon_info (keep=
siteid poc monid parameter parameterdesc method methoddescc methoddesca state
statename county countyname city cityname siteaddress aqcr aqcrname urbanarea urbanname
msa msaname landuse location latituden longitudew utmeast utmnorth utmzone
elevation units unitsname montype1 montype2 monobj1 monobj2 pmreg pmregdesc eparegion);
retain siteid poc monid parameter parameterdesc interval method methoddescc methoddesca state
statename county countyname city cityname siteaddress aqcr aqcrname urbanarea urbanname
msa msaname landuse location latituden longitudew utmeast utmnorth utmzone
elevation units unitsname montype1 montype2 monobj1 monobj2 pmreg pmregdesc eparegion;
set all;
data sdata.pm25_sitemon_summary (keep=
monid state statename county countyname city cityname urbanarea urbanname
msa msaname landuse location pmreg pmregdesc eparegion nocompqtr qbegin qend noobs
min pct05 pct25 median pct75 pct95 pct98 pct99 max annmean n2000q1-n2000q4 n2001q1-n2001q4
n2002q1-n2002q4 mean2000q1-mean2000q4 mean2001q1-mean2001q4 mean2002q1-mean2002q4);
retain monid state statename county countyname city cityname urbanarea urbanname
msa msaname landuse location pmreg pmregdesc eparegion nocompqtr qbegin qend noobs
min pct05 pct25 median pct75 pct95 pct98 pct99 max annmean n2000q1-n2000q4 n2001q1-n2001q4
n2002q1-n2002q4 mean2000q1-mean2000q4 mean2001q1-mean2001q4 mean2002q1-mean2002q4;
set all;
if primary=1;
run;
data allprim; set all;
if primary=1;
proc sort;
by state county descending pct98;
data hi98 (keep=state statename county countyname pmreg pmregdesc pct98high pct98monid);
set allprim; by state county descending pct98;
if first.county;
pct98high=pct98;
pct98monid=monid;
proc sort data=allprim;
by state county descending annmean;
data himean (keep=state statename county countyname pmreg pmregdesc annmeanmax annmeanmonid);
set allprim; by state county descending annmean;
if first.county;
annmeanmax=annmean;
annmeanmonid=monid;
proc sql; create table cts as select distinct state,county,count(*) as nosites from
allprim group by state,county;
data sdata.pm25ctymax;
retain state statename county countyname pmreg pmregdesc nosites pct98high pct98monid annmeanmax annmeanmonid;
merge cts hi98 himean; by state county;
run;