libname sdata 'd:\pm naaqs\summer03';
libname dav 'I:\lqn\PMStaffPaper\data';
*run 'meta from aqs' first;
proc sql;
create table s as select distinct site,poc_f,count(*) as ct from sdata.pmcraw_meetscomp
group by site,poc_f;
proc sort data=s; by site descending ct poc_f;
data pocf; 
retain predpocf;
set s; by site descending ct poc_f;
if first.site then predpocf=poc_f;
if first.site and last.site then output; 
else if last.site then do; multpocf='Y'; poc_f=predpocf; output; end;
run;
proc sql;
create table s as select distinct site,poc_t,count(*) as ct from sdata.pmcraw_meetscomp
group by site,poc_t;
proc sort data=s; by site ct poc_t;
data poct; 
retain predpoct;
set s; by site ct poc_t;
if first.site then predpoct=poc_t;
if first.site and last.site then output; 
else if last.site then do; multpoct='Y'; poc_t=predpoct; output; end;
run;

data met; set sdata.pmcraw_meetscomp;
if ttype='L' then do; ltp=1; output; end;
else if temperature ne . and pressure ne . then do; ltp=2; output; end;
else if tempnws ne . and pressnws ne . then do; ltp=3; output; end;
else output;run;
proc sql; create table met2 as select distinct site,ltp,count(*) as ct from met group by site,ltp;
data ltp1;set met2; if ltp=1;
nobs_ltp1=ct;
data ltp2;set met2; if ltp=2;
nobs_ltp2=ct;
data ltp3;set met2; if ltp=3;
nobs_ltp3=ct;
run;


data all; merge ltp1 ltp2 ltp3 pocf poct; by site;
drop predpocf predpoct ct;
poc=poc_f;
in=1;
run;

proc sort data=sdata.meta88101; by site poc;
data all2; 
length site $9.;
merge all sdata.meta88101;
by site poc;
if in=1;
units='105'; unitsdesc='UG/CU METER';
monid=site||'1';
pm25monid=site||compress(put(poc_f,1.0));
pm10monid=site||compress(put(poc_t,1.0));

proc sort; by site;
proc sort data=sdata.Final_pmcy20002002; by site;
data all3; merge all2 sdata.Final_pmcy20002002; by site;
siteid=site;
nocompqtr=maxnq11;
qbegin=bq; qend=eq;
noobs=an;
run;

data sdata.pmC_sitemon_info (keep=
siteid pm25monid pm10monid monid multpocf multpoct nobs_ltp1 nobs_ltp2 nobs_ltp3 state
statename county countyname city cityname siteaddress aqcr aqcrname urbanarea urbanname
msa msaname landuse location latituden longitudew utmeast utmnorth utmzone
elevation units unitsname pmreg pmregdesc eparegion);
retain 
siteid pm25monid pm10monid monid multpocf multpoct nobs_ltp1 nobs_ltp2 nobs_ltp3 state
statename county countyname city cityname siteaddress aqcr aqcrname urbanarea urbanname
msa msaname landuse location latituden longitudew utmeast utmnorth utmzone
elevation units unitsname pmreg pmregdesc eparegion;
set all3;

data sdata.pmC_sitemon_summary (keep=monid state statename county countyname city cityname urbanarea urbanname
msa msaname landuse location pmreg pmregdesc eparegion nocompqtr qbegin qend noobs
min pct05 pct25 median pct75 pct95 pct98 pct99 max annmean n2000q1-n2000q4 n2001q1-n2001q4
n2002q1-n2002q4 mean2000q1-mean2000q4 mean2001q1-mean2001q4 mean2002q1-mean2002q4);
retain monid state statename county countyname city cityname urbanarea urbanname
msa msaname landuse location pmreg pmregdesc eparegion nocompqtr qbegin qend noobs
min pct05 pct25 median pct75 pct95 pct98 pct99 max annmean n2000q1-n2000q4 n2001q1-n2001q4
n2002q1-n2002q4 mean2000q1-mean2000q4 mean2001q1-mean2001q4 mean2002q1-mean2002q4;
set all3;
proc sort data=all3;
by state county descending pct98;
data hi98 (keep=state statename county countyname pmreg pmregdesc pct98high pct98monid);
set all3; by state county descending pct98;
if first.county;
pct98high=pct98;
pct98monid=monid;
proc sort data=all3;
by state county descending annmean;
data himean (keep=state statename county countyname pmreg pmregdesc annmeanmax annmeanmonid);
set all3; by state county descending annmean;
if first.county;
annmeanmax=annmean;
annmeanmonid=monid;
proc sql; create table cts as select distinct state,county,count(*) as nosites from
all3 group by state,county;
data sdata.pmCctymax; 
retain state statename county countyname pmreg pmregdesc nosites pct98high pct98monid annmeanmax annmeanmonid;
merge cts hi98 himean; by state county;
run;