libname x 'd:\pm naaqs\summer03';
data pm10 (keep=site zdate pmt); set x.Pmtraw_meetscomp;
proc sort; by site zdate;
data pmc (keep=site zdate pmc); set x.pmcraw_meetscomp;
proc sort; by site zdate;
data pm25 (keep=site zdate pm25); set x.P88101raw_meetscomp;
pm25=v;
proc sort; by site zdate;
data all; merge pm10 pmc pm25; by site zdate;run;

data c_v_t;
set all;
if pmc ne . and pmt ne .;
proc corr noprint data=c_v_t outp=cvt;
by site;
var pmc pmt;
run;
data cvt2 (keep=site cvt);
set cvt;
if _type_='CORR';
if _name_='pmt';
cvt=pmc;

data c_v_f;
set all;
if pmc ne . and pm25 ne .;
proc corr noprint data=c_v_f outp=cvf;
by site;
var pmc pm25;
data cvf2 (keep=site cvf);
set cvf;
if _type_='CORR';
if _name_='pm25';
cvf=pmc;
run;

data t_v_f;
set all;
if pmt ne . and pm25 ne .;
proc corr noprint data=t_v_f outp=tvf;
by site;
var pmt pm25;
data tvf2 (keep=site tvf);
set tvf;
if _type_='CORR';
if _name_='pm25';
tvf=pmt;
run;

data allsites;
set x.pmc_sitemon_info x.pm10_sitemon_info x.pm25_sitemoninfo;
proc sql; create table region as select distinct siteid as site,pmreg,pmregdesc from allsites; quit;

data mergcorr; merge cvt2 cvf2 tvf2 region; by site;
proc sort; by pmreg pmregdesc;

proc means noprint; by pmreg pmregdesc;
var cvf cvt tvf;
output out=correg mean=cvf cvt tvf;
run;
data correg2; set correg; drop _type_ _freq_; if pmreg ne 0;
run;

goptions reset=all dev=cgmflwa  gaccess = gsasfile htext=1.5;
filename gsasfile "d:\pm naaqs\summer03\pm corr.cgm";
axis1 label=none offset=(5) minor=none value=none c=black;
axis2 label=none order=(-.1 to 1 by .1) minor=none c=black;
symbol1 value=triangle color=black h=2;
symbol2 value=square color=black h=2;
symbol3 value=dot color=black h=2;

run;

proc gplot data=correg2;
plot cvf*pmreg=3  cvt*pmreg=1 tvf*pmreg=2 / overlay
vref=(0 .1 .2 .3 .4 .5 .6 .7 .8 .9)
href=(1.5 2.5 3.5 4.5 5.5 6.5)
lvref=3
haxis=axis1
vaxis=axis2;
run;
quit;