%macro rawdata(lib,parm,intrvl,styear,endyear,flag,vname,userid,userpasswd);
%if &intrvl eq 1 %then %let hd=h;
%else %let hd=d;
%let rdsn=&lib..rdd&parm.d&styear&endyear&hd&sysdate;
%let sd=01-JAN-&styear;
%let ed=31-DEC-&endyear;
%let fname=&lib..p&parm;
libname aqs oracle user=&userid pw=&userpasswd path='aqsprod';
* change v_production_raw_data to current_data;
proc sql;
     connect to oracle (user=&userid password=&userpasswd path="aqsprod" buffsize=100);
     create table temp as
     select * from connection to oracle (
select  sites.cc_cn_stt_state_code||sites.cc_cn_county_code||sites.site_id as site,
        monitors.poc as poc,monitors.mo_id as mo_id,
        current_data.sampling_begin_datetime as datetime, protocols.un_unit as units,
        protocols.sm_methodology_code as method,
        sites.site_latitude as latitude,
        sites.site_longitude as longitude,
		sites.cc_ci_city_code as city,
		sites.ls_location_setting as loc,
%if %upcase(&flag) eq Y %then  %do;
        qualifier_details.qu_qualifier_code as flag,
        current_data.epa_concurrence_ind as concurr,
%end;
 		current_data.std_sample_value as &vname
        from    monitors monitors,
        monitor_protocols monitor_protocols,
        protocols protocols,
%if %upcase(&flag) eq Y %then %do;
        qualifier_details qualifier_details,
%end;
        current_data current_data,
        sites sites
where   monitors.mo_id = monitor_protocols.mo_mo_id and
        protocols.pro_id = monitor_protocols.pro_pro_id and
        monitor_protocols.mo_mo_id = current_data.mp_mo_mo_id and
        monitor_protocols.mp_id = current_data.mp_mp_id and
%if %upcase(&flag) eq Y %then %do;
        current_data.rd_id = qualifier_details.rd_rd_id(+) and
%end;
        sites.si_id = monitors.si_si_id and
        sites.cc_cn_stt_state_code <> 'CC' and
        sites.cc_cn_stt_state_code <> '80' and
        protocols.sd_duration_code = %unquote(%str(%'&intrvl%')) and
        monitors.pa_parameter_code = %unquote(%str(%'&parm%')) and
        upper(current_data.status_ind) = upper('p') and
        current_data.sampling_begin_datetime >= %unquote(%str(%'&sd%')) and
        current_data.sampling_begin_datetime <= %unquote(%str(%'&ed%'))
order by 1, 2, 3
);
%put &sqlxrc; *debug sql;
%put &sqlxmsg; *debug sql;
disconnect from oracle;
quit;

proc sql; create table ob as select distinct 
mot_monitor_obj_type as objective, mo_mo_id as mo_id from aqs.monitor_objectives;
quit;
proc sort; by mo_id objective;
data ob2; set ob; by mo_id objective;
if first.mo_id then n=0;
n+1;
charn='objective'||compress(put(n,2.0));
run;
proc transpose out=tran;
by mo_id; var objective; id charn;
run; 
data temp2;
set temp;
sdate=datepart(datetime);
format sdate mmddyy10.; run;
proc sort; by mo_id;
data temp3; merge temp2 tran; by mo_id;
if site ne ' ';
proc sort; by site poc datetime;
data &fname (keep= site st cou poc sdate value units f1-f10  q method hr lat long units city loc
objective1-objective5);
length f1 $2. f2-f10 $1. flag $2.;
retain n f1-f10;
set temp3; by site poc datetime;
lat=latitude;
long=longitude;
hr=hour(datetime);
st=substr(site,1,2);
cou=substr(site,3,3);
stcou=substr(site,1,5)+0;
if stcou in (25017 25021 25025 17031 26163 6037 27053 27123 36005 36047 36081 36085 36061
42101 42017 42045 42091 34005 34007 34015 04013 42003 49049 06085 53033 17027 17119 17133 
17163 29071 29099 29183 29189 29510);
drop stcou;
array f(10) f1-f10;
format sdate mmddyy10.;
if first.datetime then do;
n=0;
f1=' '; f2=' '; f3=' '; f4=' '; f5=' '; f6=' '; f7=' '; f8=' '; f9=' '; f10=' ';
end;
n+1;
do i=1 to 10;
if n=i then f(i)=flag;
if i=10 then do;
q=qtr(sdate);
parm=%eval(&parm+0);
if parm=81102 then units='001';
else if parm in (88101 85101) then units='105';
else if parm=68105 then units='017';
else if units=68108 then units='059';
if last.datetime then output;
end;
end;
run;
%mend;
libname x 'd:\pm naaqs\summer03';
%rawdata(x,68105,7,2000,2002,y,value,abc,mypassword);
run;