%macro stats_10_coarse(p,styear,endyear);

libname x 'd:\pm naaqs\summer03';

%do runyr= &styear %to &endyear;

%put ***year=&runyr***;

data tempraw;
%if %upcase(&p)=PMT %then %do;
set x.Pm10raw_lshd;
%put ***using x.Pm10raw_lshd***;
%end;

%else %if %upcase(&p)=PMC %then %do;
set x.coarseraw;
%put ***using x.coarseraw***;
%end;
year=year(zdate);
q=qtr(zdate);

run;

data pm;
set tempraw;
if year=&runyr;
if &p ne .;

run;

*calculate means and num obs;
proc sort data=pm; by site  q;
proc means noprint; by site  q; var &p;
output out=qtab mean=mean n=n;
data t1;
set qtab; if q=1;
mean&runyr.q1=mean;
n&runyr.q1=n;
data t2;
set qtab; if q=2;
mean&runyr.q2=mean;
n&runyr.q2=n;
data t3;
set qtab; if q=3;
mean&runyr.q3=mean;
n&runyr.q3=n;
data t4;
set qtab; if q=4;
mean&runyr.q4=mean;
n&runyr.q4=n;
run;
*merge annual stats;
data tab&runyr;
merge t1 t2 t3 t4; by site ;
drop n mean q _freq_ _type_ nc an i;


proc sort; by site ;

run;
%end;

%let y2 =%eval(&styear+1);

*Merge 3 year stats;
data allbut;
retain nq11 maxnq11;
array mn(12) mean&styear.q1-mean&styear.q4 mean&y2.q1-mean&y2.q4 mean&endyear.q1-mean&endyear.q4;
array nobs(12) n&styear.q1-n&styear.q4 n&y2.q1-n&y2.q4 n&endyear.q1-n&endyear.q4;
merge tab&styear tab&y2 tab&endyear;
by site ;nq11=0;
maxnq11=0;
do i=1 to 12;

    if nobs(i) ge 11 then nq11+1;
    if nobs(i) lt 11 then do;
        if nq11 ne 0 then do;
            if nq11 ge 8 then nq11=8;
            else if nq11 ge 4 then nq11=4;
            maxnq11=max(of maxnq11 nq11);
            if maxnq11=nq11 then do; eq=i-1; bq=eq-nq11+1; end;
            nq11=0;
        end;
    end;
    else if i=12 then do;
            if nq11=12 then nq11=12;
            else if nq11 ge 8 then nq11=8;
            else if nq11 ge 4 then nq11=4;
            maxnq11=max(of maxnq11 nq11);
            if maxnq11=nq11 then do; eq=i; bq=eq-nq11+1; end;
    end;
if maxnq11 lt 4 then do; bq=0; eq=0; maxnq11=.; end;
end;

do i=1 to 12;
if i lt bq or i gt eq then do;
mn(i)=.;
nobs(i)=.;
end;
end;
annmean=mean(of mean&styear.q1-mean&styear.q4
mean&y2.q1-mean&y2.q4 mean&endyear.q1-mean&endyear.q4);

run;

data keepq (keep=site  bq eq);
set allbut;

data tempraw2; set tempraw;
if year=&y2 then q=q+4;
if year=&endyear then q=q+8;
if &p ne .;
run;

data keepraw; merge keepq tempraw2; by site ;
if q ge bq and q le eq;
run;

data x.&p.raw_meetscomp; set keepraw;



*Calculate 98th percentile;
proc sql;
create table cts as select distinct site,count(*) as an
from keepraw group by site;

proc sort data=keepraw; by site descending &p;
data pmreg; merge cts keepraw; by site ;

data p98 (keep=site  pct98 an nc);
set pmreg;by site descending &p;
retain nc np;
if first.site then do;
nc=an-int(.98*an);
np=0;
end;

np+1;
if np = nc then do;
PCT98=round(&p,.1);
output;
end;
run;

proc sort data=keepraw;
by site ;
proc univariate noprint data=keepraw;
by site ;
var &p;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX p99=pct99;
run;

data x.final_&p.y&styear&endyear;
merge uniout allbut p98; by site ;
if maxnq11 gt 0;
run;

proc sql; select distinct maxnq11,count(*) from x.final_&p.y&styear&endyear group by maxnq11; 
quit;

%mend;

run;


libname x 'D:\PM NAAQS\summer03';
%stats_10_coarse(pmc,2000,2002);
run;